SONAME and custom packages
--------------------------

Depending on the context of the installation and the configuration
options you select, if you a recompiling for your local system then
you may find you want to be able to control the soname of your PETSc
shared library.  You can do this with the ./configure option

   --shared-library-extension=<string>
   
The given string as added to the standard library name and to the soname,
e.g. changing libpetsc.so.3.6 to libpetsc<string>.so.3.6

The standard Debian build uses 
  --shared-library-extension=_real 
for the default build supporting real numbers, and 
  --shared-library-extension=_complex
for the build supporting complex numbers.


Alternatives Priorities
-----------------------

The preferred PETSc installation is linked to /usr/lib/petsc:

  update-alternatives --config petsc
  
and the corresponding preferred shared library is linked in
/usr/lib/<arch> in a separately managed alternative link:

  update-alternatives --config libpetsc.so.3.6

(e.g. linking to libpetsc_real.so.3.6.3 or libpetsc_complex.so.3.6.3)

The priorities of the alternatives used in automatic alternatives
configuration are organised to prioritise the stripped over debug
version and the real over the complex version. The priorities
therefore are:

  UDC

U is an upstream value and D and C are single digits
i.e.

  U = upstream version e.g. 3.6.3
  
  D = stripped (D=7) or debug version (D=3)
  
  C = real (C=7) or complex (C=3)

Digits 7 and 3 are chosen to given local administrators more freedom
to set their own priorities, higher or lower, for custom builds.

